unit Spi00AM;

interface

uses Windows;

{$E .spi}

const
	SpiNotImplement		= -1;	// ̋@\̓CvgĂȂ
	SpiAllRight			= 0;	// I
	SpiAbort			= 1;	// R[obN֐0Ԃ̂œWJ𒆎~
	SpiUnknownFormat	= 2;	// m̃tH[}bg
	SpiOutOfOrder		= 3;	// f[^Ă
	SpiNoMemory			= 4;	// [mۏoȂ
	SpiMemoryError		= 5;	// [G[iLockoȂAj
	SpiFileReadError	= 6;	// t@C[hG[
	SpiReservedError	= 7;	// \idlj
	SpiWindowError		= 7;	// JȂ (dlOG[R[h)
	SpiInternalError	= 8;	// G[
	SpiFileWriteError	= 9;	// ݃G[ (dlOG[R[h)
	SpiEndOfFile		= 10;	// t@CI[ (dlOG[R[h)

type
	// FileInfo
	TFileInfo = packed record
		Method:    array[0..7] of Char;
		Position:  Longint;
		CompSize:  Longint;
		FileSize:  Longint;
		TimeStamp: Longint;
		Path:      array[0..199] of Char;
		FileName:  array[0..199] of Char;
		CRC:       Longint;
	end;
	PFileInfo = ^TFileInfo;

	// ProgressCallback
	TProgressCallback = function(nNum, nDenom: Integer; lData: Longint): Integer; stdcall;

    PByte = ^Byte;

    //̃vOCp̍\
    TLHaH2 = packed record
        Size:       Word;                   // Swb_̑傫
        Method:     array[0..4] of Char;    // k@̎
        Compsize:   Longword;               // k̃TCY
        FileSize:   Longword;               // ̃t@CTCY
        Timestamp:  Longint	;               // t@C̍XV
        Reserved:   Byte;                   // \ς (0x20 Œ)
        Level:      Byte;                   // wb_̃x (0x02)
        CRC:        Word;                   // t@CCRC16
        OS:         Byte;                   // ̃o쐬OS
        HeaderSize: Word;                   // ŏ̊gwb_̃TCY
    end;
    PLHah2 = ^TLHaH2;

const
    { A[JCuwb_̃TCY }
    HeadBufSize = SizeOf(TLHaH2);
    // Plug-in APIo[W
    PlugInfo0 = '00AM';
    // Plug-inAo[Wy copyright
    PlugInfo1 = 'lh0 extract library';
    // \IȊgq ('*.JPG' '*.JPG;*.JPEG' Ȃ)
    PlugInfo2 = '*.lzh';
    // t@C`
    PlugInfo3 = 'LZH(LH0) file(*.LZH)';
    { Ƒ₷ꍇ GetPluginInfo ֐ɂ }

{ՂƂ}
function GetPluginInfo(InfoNo: Integer; Buf: PChar; BufLen: Integer): Integer; stdcall;
function IsSupported(FileName: PChar; DW: DWORD): Integer; stdcall;
function GetArchiveInfo(
    Buf: PChar; Len: Longint; Flag: Integer;
    var InfoHandle: HLocal
): Integer; stdcall;
function GetFileInfo(
    Buf: PChar; Len: Longint; FileName: PChar; Flag: Integer;
    var FileInfo: TFileInfo
): Integer; stdcall;
function GetFile(
    Src: PChar; Len: Longint; Dest: PChar; Flag: Integer;
    ProgressCallback: TProgressCallback; lData: Longint
): Integer; stdcall;
//function ConfigurationDlg(Parent: HWND; fnc: Integer): Integer; stdcall;

exports
//	ConfigurationDlg,
	GetPluginInfo,
	IsSupported,
	GetArchiveInfo,
	GetFileInfo,
	GetFile;

implementation

// Plug-inɊւ𓾂
function GetPluginInfo(InfoNo: Integer; Buf: PChar; BufLen: Integer): Integer; stdcall;
var
    PlugInfo : PChar;
begin
    Result := 0;
    PlugInfo := nil;
    case InfoNo of
        0: PlugInfo := PlugInfo0;
        1: PlugInfo := PlugInfo1;
        2: PlugInfo := PlugInfo2;
        3: PlugInfo := PlugInfo3;
    end;

    if (PlugInfo <> nil) then
    begin
        lstrcpyn(Buf, PlugInfo, BufLen);
        Result := lstrlen(Buf);
    end;
end;

// WJ\(ΉĂ)t@C`ׂ
function IsSupported(FileName: PChar; DW: DWORD): Integer; stdcall;
var
    PLha : PLHah2;
    Buf : array[0..HeadBufSize-1] of Byte;
    ReadBytes : DWORD;
begin
    Result := 0;

    if ((DW and $FFFF0000) = 0) then
    begin
        // DW̓t@Cnh
        if (ReadFile(DW, Buf, HeadBufSize, ReadBytes, nil) = False) then Exit;
        PLha := @Buf;
    end
    else
    begin
        // DW̓obt@ւ̃|C^
        PLha := Pointer(DW);
    end;


    // tH[}bgmF
    with PLha^ do
    begin
    if (//(CompareMem(Method, '-lh0-', 5)
          (    (Method[0] = '-')
           and (Method[1] = 'l')
           and (Method[2] = 'h')
           and (Method[3] = '0')
           and (Method[4] = '-')
          )
      and (CompSize = FileSize)
      and (Reserved = $20)
      and (Level = $02)
        )
    then Result := 1;
    end;
end;

// A[JCûׂẴt@C̏擾 
function GetArchiveInfo( 
Buf: PChar; Len: Longint; Flag: Integer; 
var InfoHandle: HLocal 
): Integer; stdcall;
var
    LhaH : TLHaH2;
    ReadBytes : DWORD;
    hf : THandle;
	PInfo : PFileInfo;
    FileCount : Integer;
    I : Integer;
    ExHBuf: PByte;
    Size : Integer;
begin
    //͖Ή
    if ((flag and 7) <> 0) then
    begin
        Result := SpiNotImplement;
        Exit;
    end;

    //t@CI[v
    // buf̓t@C
    hf := CreateFile(Buf, GENERIC_READ, FILE_SHARE_READ, nil, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, 0);
    if (hf = INVALID_HANDLE_VALUE) then
    begin
        Result := SpiFileReadError;
        Exit;
    end;

    //t@CJEg
    FileCount := 0;
    while True do
    begin
        ReadFile(hf, LhaH, SizeOf(TLHaH2), ReadBytes, nil);
        if ((ReadBytes < SizeOf(TLHaH2)) or (LhaH.Size = 0)) then Break;
        Inc(FileCount);
        SetFilePointer(hf, LhaH.compsize +LhaH.size -SizeOf(TLHaH2), nil, FILE_CURRENT)
    end;

    // o͗p̃̊蓖(t@C+1̗̈悪Kv)A0ŏĂ
    InfoHandle := LocalAlloc(LHND, SizeOf(TFileInfo) * (FileCount +1));
    if (InfoHandle = HLOCAL(nil)) then
    begin
        CloseHandle(hf);
        Result := SpiNoMemory;
        Exit;
    end;

    PInfo := LocalLock(InfoHandle);
    SetFilePointer(hf, 0, nil, FILE_BEGIN);
    ExHBuf := Pointer(LocalAlloc(LMEM_FIXED	, $10000));
    for I:=1 to FileCount do
    begin
        // Method(7+'\0'ȓł̓Kȕԋp)
        lstrcpy(PInfo.Method, '-lh0-');
        PInfo.Position := SetFilePointer(hf, 0, nil, FILE_CURRENT);
        ReadFile(hf, LhaH, SizeOf(TLHaH2), ReadBytes, nil);
        PInfo.CompSize := LhaH.CompSize;
        PInfo.FileSize := LhaH.FileSize;
        PInfo.Timestamp := LhaH.Timestamp;
        Size := LhaH.HeaderSize;
        while Size<>0 do
        begin
            ReadFile(hf, ExHBuf^, Size, ReadBytes, nil);
            if (ExHBuf^ = $01) then
            begin
                lstrcpyn(PInfo.FileName, PChar(ExHBuf) +1, Size -3);
                Break;
            end
            else
            begin
                Size := Word((PChar(ExHBuf) +Size -2)^);
            end;
        end;
        SetFilePointer(hf, PInfo.Position +LhaH.Size +LhaH.CompSize, nil, FILE_BEGIN);
        Inc(PInfo);
    end;
    PInfo.Method[0] := Char(0);
    LocalFree(HLOCAL(ExHBuf));
    CloseHandle(hf);
    Result := SpiAllRight;
end;

// A[JCu̎w肵t@C̏擾
function GetFileInfo(
Buf: PChar; Len: Longint; FileName: PChar; Flag: Integer;
var FileInfo: TFileInfo
): Integer; stdcall;
var
    LhaH : TLHaH2;
    ReadBytes : DWORD;
    hf : THandle;
    ExHBuf: PByte;
    Size : Integer;
begin
    //͖Ή
    if ((flag and 7) <> 0) then
    begin
        Result := SpiNotImplement;
        Exit;
    end;

    //t@CI[v
    // buf̓t@C
    hf := CreateFile(Buf, GENERIC_READ, FILE_SHARE_READ, nil, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, 0);
    if (hf = INVALID_HANDLE_VALUE) then
    begin
        Result := SpiFileReadError;
        Exit;
    end;

    Result := SpiAllRight;
    ExHBuf := Pointer(LocalAlloc(LMEM_FIXED	, $10000));
    // Method(7+'\0'ȓł̓Kȕԋp)
    lstrcpy(FileInfo.Method, '-lh0-');
    ZeroMemory(@FileInfo, SizeOf(TFileInfo));
    lstrcpy(FileInfo.Method, '-lh0-');
    while True do
    begin
        FileInfo.Position := SetFilePointer(hf, 0, nil, FILE_CURRENT);
        ReadFile(hf, LhaH, SizeOf(TLHaH2), ReadBytes, nil);
        if ((ReadBytes < SizeOf(TLHaH2)) or (LhaH.Size = 0)) then
        begin
            Result := SpiOutOfOrder;
            Break;
        end;
        FileInfo.CompSize := LhaH.CompSize;
        FileInfo.FileSize := LhaH.FileSize;
        FileInfo.Timestamp := LhaH.Timestamp;
        Size := LhaH.HeaderSize;
        while Size<>0 do
        begin
            ReadFile(hf, ExHBuf^, Size, ReadBytes, nil);
            if (ExHBuf^ = $01) then
            begin
                lstrcpyn(FileInfo.FileName, PChar(ExHBuf) +1, Size -3);
                Break;
            end
            else
            begin
                Size := Word((PChar(ExHBuf) +Size -2)^);
            end;
        end;
        if (lstrcmpi(FileName, FileInfo.FileName) = 0) then Break;
        SetFilePointer(hf, FileInfo.Position +LhaH.Size +LhaH.CompSize, nil, FILE_BEGIN);
    end;
    LocalFree(HLOCAL(ExHBuf));
    CloseHandle(hf);
end;

// A[JCũt@C擾
function GetFile(
Src: PChar; Len: Longint; Dest: PChar; Flag: Integer;
ProgressCallback: TProgressCallback; lData: Longint
): Integer; stdcall;
var
    LhaH : TLHaH2;
    ReadBytes : DWORD;
    hf : THandle;
    PHMem : PHandle;//^HLOCAL;
    DataBuf : PByte;
begin
    //t@Co͖Ή
    if ((flag and $700) = 0) then
    begin
        Result:=SpiNotImplement;
        Exit;
    end;

    //͖Ή
    if ((flag and 7) <> 0) then
    begin
        Result := SpiNotImplement;
        Exit;
    end;

    // Src̓t@C
    hf := CreateFile(Src, GENERIC_READ, FILE_SHARE_READ, nil, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, 0);
    if (hf = INVALID_HANDLE_VALUE) then
    begin
        Result := SpiFileReadError;
        Exit;
    end;
    SetFilePointer(hf, Len, nil, FILE_BEGIN);
    ReadFile(hf, LhaH, SizeOf(TLHaH2), ReadBytes, nil);
    PHMem := PHandle(Dest);
    PHMem^ := LocalAlloc(LMEM_MOVEABLE, LhaH.FileSize);
    if (PHMem^ = HLOCAL(nil)) then
    begin
        CloseHandle(hf);
        Result := SpiNoMemory;
        Exit;
    end;
    DataBuf := LocalLock(PHMem^);
    if (DataBuf = nil) then
    begin
        CloseHandle(hf);
        Result := SpiMemoryError;
        Exit;
    end;
    SetFilePointer(hf, LhaH.Size - SizeOf(TLHaH2), nil, FILE_CURRENT);
    ReadFile(hf, DataBuf^, LhaH.FileSize, ReadBytes, nil);
    CloseHandle(hf);
    Result := SpiAllRight;
end;


// Plug-inݒ_CAO\
function ConfigurationDlg(Parent: HWND; fnc: Integer): Integer; stdcall;
begin
    Result:=SpiNotImplement;
end;


end.
